<%@ Page 
    Language="C#"
    Inherits="Demo_AddReference"
    CodeFile="AddReference.aspx.cs"
    MasterPageFile="~/App_Pages/Home.master"
    AutoEventWireup="true"
    EnableTheming="true"
    Theme="Default"
    Title="MicroMighty, Inc : Add Reference"
%>
<asp:Content Runat="Server" ID="_body" ContentPlaceHolderID="_contentPlaceHolderBody">

<div style="margin-left:10px;">

    <div style="margin-bottom:30px;">
        <table cellpadding="0" cellspacing="0">
            <tr>
                <td align="left" class="BoxFixedSilverLeft" style="vertical-align:top;">
                </td>
                
                <td class="BoxFixedSilverMiddle" style="vertical-align:top; padding-left:20px; padding-right:20px;">
                    <div style="margin-top:17px; margin-bottom:3px;">
                        <span class="Title">Add Reference</span><br />
                    </div>
                    <span class="Copyright" style="font-weight:normal;"
                        >Sample Web Page</span><br />
                </td>
                
                <td align="right" class="BoxFixedSilverRight" style="vertical-align:top;">
                </td>
            </tr>
        </table>
    </div>


    <div class="TitlePage" style="margin-bottom:10px;">
        How to add a reference to the MicroMighty SDK DLLs
    </div>
    <div style="margin-bottom:20px;">
        Follow these steps
    </div>

    <ul class="CustomUL">

        <li class="ArrowBlack" style="margin-bottom:20px; text-align:justify;">Open Visual Studio and load your web project</li>

        <li class="ArrowBlack" style="margin-bottom:20px; text-align:justify;">Right click the web project and choose "Add Reference"<br />
            <div style="margin-top:10px;">
                <img src="Assets/Images/AddReference.png" height="292" width="361" 
                    style="border-color:Silver; border-width:1px; border-style:solid;" alt="" />
            </div>
        </li>

        <li class="ArrowBlack" style="margin-bottom:20px; text-align:justify;">Go one level up and select the DLLs from ThirdParty/Library/MicroMighty.SDK<br />
            <div style="margin-top:10px;">
                <img src="Assets/Images/AddReferenceBrowse.png" height="400" width="478" 
                    style="border-color:Silver; border-width:1px; border-style:solid;" alt="" />
            </div>
        </li>

        <li class="ArrowBlack" style="margin-bottom:0px; text-align:justify;">Done, now you can right click the web project again and see the added references.<br />
        </li>
        
    </ul>


    <div class="TitlePage" style="margin-top:30px; margin-bottom:10px;">
        Once the references were added to the Visual Studio project
    </div>
    <div style="margin-bottom:20px;">
        Include the name spaces in your source code in order to gain access to the SDK features
    </div>
    <div style="margin-bottom:20px;">
        For example:
    </div>
    <ul class="CustomUL">
        <li class="ArrowBlack">For C# :<br />
            using MicroMighty.SDK.Net.Tools;<br />
            using MicroMighty.SDK.Web.Tools;</li>
        <li class="ArrowBlack">For VB :<br />
            Imports MicroMighty.SDK.Net.Tools<br />
            Imports MicroMighty.SDK.Web.Tools</li>
    </ul>

</div>

</asp:Content>