﻿<%@ Page 
    Language="C#"
    Inherits="Demo_Default"
    CodeFile="Default.aspx.cs"
    MasterPageFile="~/App_Pages/Home.master"
    AutoEventWireup="true"
    EnableTheming="true"
    Theme="Default"
    Title="MicroMighty, Inc : SDK"
%>
<asp:Content Runat="Server" ID="_body" ContentPlaceHolderID="_contentPlaceHolderBody">

<div style="margin-left:10px;">

    <div style="margin-bottom:20px;">
        <table cellpadding="0" cellspacing="0">
            <tr>
                <td align="left" class="BoxFixedShortSilverLeft" style="vertical-align:top;">
                </td>
                
                <td align="left" class="BoxFixedShortSilverMiddle" style="vertical-align:top;">
                    <div style="margin-top:13px; margin-left:20px; margin-right:20px;">
                        <span class="Title">About This Project</span>
                    </div>
                </td>
                
                <td align="right" class="BoxFixedShortSilverRight" style="vertical-align:top;">
                </td>
            </tr>
        </table>
    </div>
    
    <div style="margin-bottom:10px; text-align:justify;">
	    The MicroMighty Software Development Kit (SDK) is a collection of objects and components that were designed to help ASP.NET developers to add commonly used tools and functionality to their project instantly without spending valuable time on lower level coding while using our ready to use tested objects.<br />
    </div>
    
    <ul class="CustomUL" style="margin-bottom:20px;">
	    <li class="ArrowBlack">Get the latest version at <a href="http://MicroMighty.com/SDK/Downloads/MicroMighty_SDK.zip" 
	         >http://MicroMighty.com/SDK/Downloads/MicroMighty_SDK.zip</a></li>
	    <li class="ArrowBlack">See product documentation at <a href="http://MicroMighty.com/SDK/Docs/SDKHelp.zip" 
	        >http://MicroMighty.com/SDK/Docs/SDKHelp.zip</a></li>
	    <li class="ArrowBlack">Experience a live version of this project at <a href="http://MicroMighty.com/SDK" 
	        >http://MicroMighty.com/SDK</a></li>
    </ul>
    
    <div style="margin-top:30px; margin-bottom:20px;">
        <table cellpadding="0" cellspacing="0">
            <tr>
                <td align="left" class="BoxFixedShortSilverLeft" style="vertical-align:top;">
                </td>
                
                <td align="left" class="BoxFixedShortSilverMiddle" style="vertical-align:top;">
                    <div style="margin-top:13px; margin-left:20px; margin-right:20px;">
                        <span class="Title">Namespaces And Demo Files</span>
                    </div>
                </td>
                
                <td align="right" class="BoxFixedShortSilverRight" style="vertical-align:top;">
                </td>
            </tr>
        </table>    
    </div>
        

    <table cellpadding="0" cellspacing="0" width="100%">
        <tr>
            <td align="left" style="vertical-align:top;">
                <ul class="CustomUL" style="margin-top:10px; font-weight:bold;">
	                <li class="PlusBlack"><a href="<%=Page.ResolveUrl("~/Docs/html/N_MicroMighty_SDK_Net_Helpers.htm")%>" 
	                    target="_blank">MicroMighty.SDK.Net.Helpers</a></li>
	                <li class="PlusBlack"><a href="<%=Page.ResolveUrl("~/Docs/html/N_MicroMighty_SDK_Net_Tools.htm")%>" 
	                    target="_blank">MicroMighty.SDK.Net.Tools</a></li>
                        <ul class="CustomUL">
	                        <li class="ArrowBlack"><a href="<%=Page.ResolveUrl("~/EasyCache/EasyCache.aspx")%>"
	                            >Easy Cache</a></li>
	                        <li class="ArrowBlack"><a href="<%=Page.ResolveUrl("~/EasyEmailSender/EasyEmailSender.aspx")%>"
	                            >Easy Email Sender</a></li>
                        </ul>
	                <li class="PlusBlack"><a href="<%=Page.ResolveUrl("~/Docs/html/N_MicroMighty_SDK_Net_Types.htm")%>" 
	                    target="_blank">MicroMighty.SDK.Net.Types</a></li>
            	        
	                <li class="PlusBlack"><a href="<%=Page.ResolveUrl("~/Docs/html/N_MicroMighty_SDK_Web_HttpModules.htm")%>" 
	                    target="_blank">MicroMighty.SDK.Web.HttpModules</a></li>
                        <ul class="CustomUL">
                            <li class="ArrowBlack"><a href="<%=Page.ResolveUrl("~/HTTPCompressionModule/HTTPCompressionModule.aspx")%>"
                                >HTTP Compression Module</a></li>
                            <li class="ArrowBlack"><a href="<%=Page.ResolveUrl("~/HTTPPrefixModule/HTTPPrefixModule.aspx")%>"
                                >HTTP Prefix Module</a></li>
                        </ul>	        
	                <li class="PlusBlack"><a href="<%=Page.ResolveUrl("~/Docs/html/N_MicroMighty_SDK_Web_Tools.htm")%>" 
	                    target="_blank">MicroMighty.SDK.Web.Tools</a></li>
                        <ul class="CustomUL">
                            <li class="ArrowBlack"><a href="<%=Page.ResolveUrl("~/EasyErrorHandler/EasyErrorHandler.aspx")%>"
                                >Easy Error Handler</a></li>
                        </ul>
                </ul>
            </td>
            <td align="right" style="vertical-align:bottom;">
                <div style="margin-top:10px;">
                        <img src="http://micromighty.com/SDK/Assets/Images/SDKPowerup.jpg" 
                        width="276" height="230" style="border-style:none;" alt="" /><br />
                </div>
            </td>
        </tr>
    </table>



</div>


</asp:Content>