<%@ Page 
    Language="C#"
    Inherits="Demo_EasyCache"
    CodeFile="EasyCache.aspx.cs"
    MasterPageFile="~/App_Pages/Home.master"
    AutoEventWireup="true"
    EnableTheming="true"
    Theme="Default"
    Title="MicroMighty, Inc : EasyCache"
%>
<asp:Content Runat="Server" ID="_body" ContentPlaceHolderID="_contentPlaceHolderBody">

<div style="margin-left:10px;">

    <div style="margin-bottom:30px;">
        <table cellpadding="0" cellspacing="0">
            <tr>
                <td align="left" class="BoxFixedSilverLeft" style="vertical-align:top;">
                </td>
                
                <td class="BoxFixedSilverMiddle" style="vertical-align:top; padding-left:20px; padding-right:20px;">
                    <div style="margin-top:17px; margin-bottom:3px;">
                        <span class="Title">EasyCache Class</span><br />
                    </div>
                    <a href="<%=Page.ResolveUrl("~/Docs/html/N_MicroMighty_SDK_Net_Tools.htm")%>" 
                        target="_blank"><span class="Copyright" style="font-weight:normal; cursor:pointer;"
                        >MicroMighty.SDK.Net.Tools Namespace</span></a><br />
                </td>
                
                <td align="right" class="BoxFixedSilverRight" style="vertical-align:top;">
                </td>
            </tr>
        </table>
    </div>

    <div style="margin-bottom:10px;">
        <table cellpadding="0" cellspacing="0">
            <tr>
                <td align="left" class="BoxFixedShortSilverLeft" style="vertical-align:top;">
                </td>
                
                <td align="left" class="BoxFixedShortSilverMiddle" style="vertical-align:top;">
                    <div style="margin-top:13px; margin-left:20px; margin-right:20px;">
                        <span class="Title">Usage</span>
                    </div>
                </td>
                
                <td align="right" class="BoxFixedShortSilverRight" style="vertical-align:top;">
                </td>
            </tr>
        </table>
    </div>
        <div style="margin-bottom:20px;">
            A reference to the SDK DLLs is required, see <a href="<%=Page.ResolveUrl("~/AddReference.aspx")%>" 
                >how to add a reference to the MicroMighty SDK DLLs</a>.<br />
            The class can be used directly like a static class without being instantiated (see example files).<br />
        </div>

        <div style="margin-bottom:30px;">
            Practical Examples
            <ul class="CustomUL">
	            <li class="ArrowBlack"><a href="<%=Page.ResolveUrl("~/EasyCache/Cache.aspx")%>"
	                >Cache (C#)</a></li>
	            <li class="ArrowBlack"><a href="<%=Page.ResolveUrl("~/EasyCache/CacheVB.aspx")%>"
	                >Cache (VB)</a></li>
            </ul>
        </div>

        <div style="margin-bottom:10px;">
            <table cellpadding="0" cellspacing="0">
                <tr>
                    <td align="left" class="BoxFixedShortSilverLeft" style="vertical-align:top;">
                    </td>
                    
                    <td align="left" class="BoxFixedShortSilverMiddle" style="vertical-align:top;">
                        <div style="margin-top:13px; margin-left:20px; margin-right:20px;">
                            <span class="Title">Configuration</span>
                        </div>
                    </td>
                    
                    <td align="right" class="BoxFixedShortSilverRight" style="vertical-align:top;">
                    </td>
                </tr>
            </table>
        </div>
        Web.Config should include the following variables in order for EasyCache to run correctly,<br />
        If no variables added then the module will not run and EasyCacheActive will be set to "false".
        
        
        <div style="margin-top:20px;margin-bottom:20px;">
            Add the following entries in the "&lt;appSettings&gt;" section of "&lt;configuration&gt;"<br />
        </div>

        <div class="AreaWrap" style="margin-bottom:30px;">
            <font color="#0000ff" size="2"><font color="#0000ff" size="2">&lt;!--<font color="#008000" size="2"><font color="#008000" size="2"
            > MicroMighty SDK : EasyEmailSender Variables </font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">--&gt;</font></font></font><br />

            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >key</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >EasyCacheActive</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >value</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            >true</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />
            
            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >key</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >EasyCacheCommaSeparatedCacheReceiverURLsOfAllowedMachines</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >value</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            ></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />
        </div>

        <div style="margin-top:20px;margin-bottom:20px;">
            Make sure that IIS is configured to allow cache objects to last enough time based on your needs<br />
        </div>
        
        <div class="AreaWrap" style="margin-bottom:30px;">
            Internet Information Services (IIS) -> Application Pools -> Your_Application_Pool -> Advanced Settings<br />

            <ul class="CustomUL">
                <li class="VBlack" style="text-align:justify;">
                    Set the "Process Model" -> Idle Time-out to : 43200 minutes<br />
                </li>
                <li class="VBlack" style="text-align:justify;">
                    Set the "Recycling" -> Regular Time Interval to : 43200 minutes<br />
                    (it has to be at least whatever the Idle Time-out is)<br />
                </li>
            </ul>
            
            <div style="margin-bottom:10px;">
                The maximum value is 43200 minutes (60 minutes x 24 hours x 30 days)<br />
            </div>
            
            Also see <a href="http://www.iis.net/ConfigReference/system.applicationHost/applicationPools/add/processModel" 
                target="_blank">Process Model Settings</a> 
            and <a href="http://technet.microsoft.com/en-us/library/cc771956(WS.10).aspx" 
                target="_blank">Configure Idle Time-out Settings for an Application Pool</a><br />
        </div>
        

    <div style="margin-bottom:10px;">
        <table cellpadding="0" cellspacing="0">
            <tr>
                <td align="left" class="BoxFixedShortSilverLeft" style="vertical-align:top;">
                </td>
                
                <td align="left" class="BoxFixedShortSilverMiddle" style="vertical-align:top;">
                    <div style="margin-top:13px; margin-left:20px; margin-right:20px;">
                        <span class="Title">Notes</span>
                    </div>
                </td>
                
                <td align="right" class="BoxFixedShortSilverRight" style="vertical-align:top;">
                </td>
            </tr>
        </table>
    </div>
    <div style="margin-bottom:20px; text-align:justify;">
        <div style="margin-bottom:10px;">
            Most of the shared hosting companies do not allow to cache objects for more than just few minutes.<br />
        </div>
        <div style="margin-bottom:10px;">
            For testing in a multi machine environment on a localhost - create two or more separate web applications.
        </div>
        ProcessCachePerRequest() has a security feature that will prevent processing cache from an unauthorized 
        request URLs, if a request comes from a machine that is not in the list of allowed machines it will error out.
    </div>
    
    <ul class="CustomUL">
        <li class="ArrowBlack" style="text-align:justify;"><b>EasyCacheActive</b> is used to turn on and off caching 
            (value can be "true" or "false"), cache objects can still be removed even when EasyCache is not active 
            but no new objects will be created or used.
        </li>

	    <li class="ArrowBlack" style="text-align:justify;"><b>EasyCacheCommaSeparatedCacheReceiverURLsOfAllowedMachines</b>
	        is a comma separated list of all the machines that host the web application in a multi server environment 
	        such as web garden (it is only used if it has some value), each comma separated value must include the scheme 
	        and name of the page that is setup to receive and synchronize the cache objects, for example: 
	        "http://localhost/App1/Cache/CacheReceiver.aspx, http://localhost/App2/Cache/CacheReceiver.aspx"
	        
        </li>
    </ul>
    
</div>

</asp:Content>