<%@ Page 
    Language="C#"
    Inherits="Demo_EasyEmailSender"
    CodeFile="EasyEmailSender.aspx.cs"
    MasterPageFile="~/App_Pages/Home.master"
    AutoEventWireup="true"
    EnableTheming="true"
    Theme="Default"
    Title="MicroMighty, Inc : EasyEmailSender"
%>
<asp:Content Runat="Server" ID="_body" ContentPlaceHolderID="_contentPlaceHolderBody">

<div style="margin-left:10px;">

    <div style="margin-bottom:30px;">
        <table cellpadding="0" cellspacing="0">
            <tr>
                <td align="left" class="BoxFixedSilverLeft" style="vertical-align:top;">
                </td>
                
                <td class="BoxFixedSilverMiddle" style="vertical-align:top; padding-left:20px; padding-right:20px;">
                    <div style="margin-top:17px; margin-bottom:3px;">
                        <span class="Title">EasyEmailSender Class</span><br />
                    </div>
                    <a href="<%=Page.ResolveUrl("~/Docs/html/N_MicroMighty_SDK_Net_Tools.htm")%>" 
                        target="_blank"><span class="Copyright" style="font-weight:normal; cursor:pointer;"
                        >MicroMighty.SDK.Net.Tools Namespace</span></a><br />
                </td>
                
                <td align="right" class="BoxFixedSilverRight" style="vertical-align:top;">
                </td>
            </tr>
        </table>
    </div>

    <div style="margin-bottom:10px;">
        <table cellpadding="0" cellspacing="0">
            <tr>
                <td align="left" class="BoxFixedShortSilverLeft" style="vertical-align:top;">
                </td>
                
                <td align="left" class="BoxFixedShortSilverMiddle" style="vertical-align:top;">
                    <div style="margin-top:13px; margin-left:20px; margin-right:20px;">
                        <span class="Title">Usage</span>
                    </div>
                </td>
                
                <td align="right" class="BoxFixedShortSilverRight" style="vertical-align:top;">
                </td>
            </tr>
        </table>
    </div>
        <div style="margin-bottom:20px;">
            A reference to the SDK DLLs is required, see <a href="<%=Page.ResolveUrl("~/AddReference.aspx")%>" 
                >how to add a reference to the MicroMighty SDK DLLs</a>.<br />
        </div>

        <div style="margin-bottom:30px;">
            Practical Examples
            <ul class="CustomUL">
	            <li class="ArrowBlack"><a href="<%=Page.ResolveUrl("~/EasyEmailSender/Send.aspx")%>"
	                >Send An Email (C#)</a></li>
	            <li class="ArrowBlack"><a href="<%=Page.ResolveUrl("~/EasyEmailSender/SendVB.aspx")%>"
	                >Send An Email (VB)</a></li>
            </ul>
        </div>

        <div style="margin-bottom:10px;">
            <table cellpadding="0" cellspacing="0">
                <tr>
                    <td align="left" class="BoxFixedShortSilverLeft" style="vertical-align:top;">
                    </td>
                    
                    <td align="left" class="BoxFixedShortSilverMiddle" style="vertical-align:top;">
                        <div style="margin-top:13px; margin-left:20px; margin-right:20px;">
                            <span class="Title">Configuration</span>
                        </div>
                    </td>
                    
                    <td align="right" class="BoxFixedShortSilverRight" style="vertical-align:top;">
                    </td>
                </tr>
            </table>
        </div>
        The following variables can be added to the Web.Config as used in the examples above<br />
        (these variables can also be provided directly at runtime to the EasyEmailSender object)<br />
        
        <div style="margin-top:20px;margin-bottom:20px;">
            Add the following entries in the "&lt;appSettings&gt;" section of "&lt;configuration&gt;"<br />
        </div>

        <div class="AreaWrap" style="margin-bottom:30px;">
            <font color="#0000ff" size="2"><font color="#0000ff" size="2">&lt;!--<font color="#008000" size="2"><font color="#008000" size="2"
            > EasyEmailSender Variables </font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">--&gt;</font></font></font><br />

            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >key</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >EasyEmailSenderSMTPEnableSSL</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >value</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            >true</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />
            
            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >key</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >EasyEmailSenderSMTPPort</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >value</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            >587</font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />

            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >key</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >EasyEmailSenderSMTPHost</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >value</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            >smtp.gmail.com</font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />

            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >key</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >EasyEmailSenderSMTPUserName</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >value</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            >YourUserName@gmail.com</font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />

            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >key</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >EasyEmailSenderSMTPPassword</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >value</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            >YourPassword</font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />
        </div>

    <div style="margin-bottom:10px;">
        <table cellpadding="0" cellspacing="0">
            <tr>
                <td align="left" class="BoxFixedShortSilverLeft" style="vertical-align:top;">
                </td>
                
                <td align="left" class="BoxFixedShortSilverMiddle" style="vertical-align:top;">
                    <div style="margin-top:13px; margin-left:20px; margin-right:20px;">
                        <span class="Title">Notes</span>
                    </div>
                </td>
                
                <td align="right" class="BoxFixedShortSilverRight" style="vertical-align:top;">
                </td>
            </tr>
        </table>
    </div>
    <div style="margin-bottom:10px;">
        This example is using port 587 in order to use a "Goodle Apps" account authentication to send an email,<br />
        Based on your SMTP authentication you will need to provide different values and probably a different port.<br />
    </div>
    <div style="margin-bottom:10px;">
        The SMTP Host default port is port 25, however some servers are blocking the default port,<br />
        Check what are your SMTP variables with your hosting company or Internet Service Provider.<br />
    </div>
    
</div>

</asp:Content>