<%@ Page 
    Language="C#"
    Inherits="Demo_EasyErrorHandler"
    CodeFile="EasyErrorHandler.aspx.cs"
    MasterPageFile="~/App_Pages/Home.master"
    AutoEventWireup="true"
    EnableTheming="true"
    Theme="Default"
    Title="MicroMighty, Inc : EasyErrorHandler"
%>
<asp:Content Runat="Server" ID="_body" ContentPlaceHolderID="_contentPlaceHolderBody">

<div style="margin-left:10px;">

    <div style="margin-bottom:30px;">
        <table cellpadding="0" cellspacing="0">
            <tr>
                <td align="left" class="BoxFixedSilverLeft" style="vertical-align:top;">
                </td>
                
                <td class="BoxFixedSilverMiddle" style="vertical-align:top; padding-left:20px; padding-right:20px;">
                    <div style="margin-top:17px; margin-bottom:3px;">
                        <span class="Title">EasyErrorHandler Class</span><br />
                    </div>
                    <a href="<%=Page.ResolveUrl("~/Docs/html/N_MicroMighty_SDK_Web_Tools.htm")%>" 
                        target="_blank"><span class="Copyright" style="font-weight:normal; cursor:pointer;"
                        >MicroMighty.SDK.Web.Tools Namespace</span></a><br />
                </td>
                
                <td align="right" class="BoxFixedSilverRight" style="vertical-align:top;">
                </td>
            </tr>
        </table>
    </div>

    <div style="margin-bottom:10px;">
        <table cellpadding="0" cellspacing="0">
            <tr>
                <td align="left" class="BoxFixedShortSilverLeft" style="vertical-align:top;">
                </td>
                
                <td align="left" class="BoxFixedShortSilverMiddle" style="vertical-align:top;">
                    <div style="margin-top:13px; margin-left:20px; margin-right:20px;">
                        <span class="Title">Usage</span>
                    </div>
                </td>
                
                <td align="right" class="BoxFixedShortSilverRight" style="vertical-align:top;">
                </td>
            </tr>
        </table>
    </div>
        <div style="margin-bottom:30px;">
            This class should be used in the "Application_Error" event of "Global.asax" in order to process errors,<br />
            A reference to the SDK DLLs is required, see <a href="<%=Page.ResolveUrl("~/AddReference.aspx")%>" 
                >how to add a reference to the MicroMighty SDK DLLs</a>.<br />
        </div>

        <div style="margin-bottom:10px;">
            <table cellpadding="0" cellspacing="0">
                <tr>
                    <td align="left" class="BoxFixedShortSilverLeft" style="vertical-align:top;">
                    </td>
                    
                    <td align="left" class="BoxFixedShortSilverMiddle" style="vertical-align:top;">
                        <div style="margin-top:13px; margin-left:20px; margin-right:20px;">
                            <span class="Title">Configuration</span>
                        </div>
                    </td>
                    
                    <td align="right" class="BoxFixedShortSilverRight" style="vertical-align:top;">
                    </td>
                </tr>
            </table>
        </div>
        Web.Config should include the following variables in order for this class to run correctly,<br />
        If no variables added then the module will not run and EasyErrorHandlerActive will be set to "false".
        
        <div style="margin-top:20px;margin-bottom:20px;">
            Add the following entries in the "&lt;appSettings&gt;" section of "&lt;configuration&gt;"<br />
        </div>

        <div class="AreaWrap" style="margin-bottom:30px;">
            <font color="#0000ff" size="2"><font color="#0000ff" size="2">&lt;!--<font color="#008000" size="2"><font color="#008000" size="2"
            > MicroMighty SDK : EasyErrorHandler Variables </font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">--&gt;</font></font></font><br />

            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >key</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >EasyErrorHandlerActive</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >value</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            >true</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />

            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >key</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >EasyErrorHandlerIgnoreInvalidViewstate</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >value</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            >true</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />

            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >key</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >EasyErrorHandlerIgnoreNotExist</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >value</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            >false</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />
            
            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >key</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >EasyErrorHandlerSameErrorInterval</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >value</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            >1</font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />
        </div>

        <div style="margin-top:20px;margin-bottom:20px;">
            When an error occurs, users can be redirected to a nice custom error page instead of the common .NET 
            error details page while the error details are still getting sent via email or logged into a database table.<br />
        </div>
            
        <div style="margin-bottom:20px;">
            To allow custom errors, add the following entries in the "&lt;system.web&gt;" section of "&lt;configuration&gt;"<br />
        </div>

        <div class="AreaWrap" style="margin-bottom:30px;">
            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">customErrors</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >defaultRedirect</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >~/Error.aspx</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >mode</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            >On</font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />
            
            <font color="#0000ff" size="2">&lt;/<font color="#a31515" size="2"><font color="#a31515" size="2">customErrors</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            ><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font></font></font></font><br />
        </div>

    <div style="margin-bottom:10px;">
        <table cellpadding="0" cellspacing="0">
            <tr>
                <td align="left" class="BoxFixedShortSilverLeft" style="vertical-align:top;">
                </td>
                
                <td align="left" class="BoxFixedShortSilverMiddle" style="vertical-align:top;">
                    <div style="margin-top:13px; margin-left:20px; margin-right:20px;">
                        <span class="Title">Notes</span>
                    </div>
                </td>
                
                <td align="right" class="BoxFixedShortSilverRight" style="vertical-align:top;">
                </td>
            </tr>
        </table>
    </div>
    <div style="margin-bottom:10px;">
        See the sample "Global.asax" file attached with this project in order to learn how you can use our mail 
        object - <a href="<%=Page.ResolveUrl("~/EasyEmailSender/EasyEmailSender.aspx")%>"
	        >Easy Email Sender</a> for sending errors to the web master including an option to copy other users,<br />
	        (use our <a href="<%=Page.ResolveUrl("~/EasyEmailSender/Send.aspx")%>">Send An Email</a> practical example 
	        in order to make sure that your SMTP variables are correct)<br />
    </div>
    <div style="margin-bottom:10px;">
        An instance of this class should be created inside the "Application_Error" event of "Global.asax" and
        the boolean property "ErrorReported" can be used to check if there was an error detected to be handled with.
        <br />
    </div>
    <div style="margin-bottom:20px;">
        For testing, an error can be simply raised by using: throw new ApplicationException("Error for testing");<br />
        See the attached sample file for rasing an error <a href="<%=Page.ResolveUrl("http://micromighty.com/Content/Error/RaiseAnError.aspx")%>"
            >EasyErrorHandler/RaiseAnError.aspx</a><br />
        (make sure you setup SMTP user name, password, etc. in Web.config)
    </div>
    
    <ul class="CustomUL">
        <li class="ArrowBlack" style="text-align:justify;"><b>EasyErrorHandlerActive</b> is used to turn on and off error reporting
            (value can be "true" or "false")
        </li>

        <li class="ArrowBlack" style="text-align:justify;"><b>EasyErrorHandlerIgnoreInvalidViewstate</b> is used to turn on and off error reporting
            for Invalid viewstate errors that are mostly generated due to an Internet Explorer bug, for more information see 
            <a href="https://connect.microsoft.com/IE/feedback/ViewFeedback.aspx?FeedbackID=467062" target="_blank" 
                >Invalid viewstate when loading ScriptResource.axd or WebResource.axd</a> 
            (value can be "true" or "false")
        </li>

        <li class="ArrowBlack" style="text-align:justify;"><b>EasyErrorHandlerIgnoreNotExist</b> is used to turn on and off error reporting
            for non existing files as search engines and bots may try to access files that do not exist (value can be "true" or "false")
        </li>

	    <li class="ArrowBlack" style="text-align:justify;"><b>EasyErrorHandlerSameErrorInterval</b>
	        is the time in minutes that is used to make sure that not too many emails are being sent 
	        all together in a case of an error generated by many users and caused by the same reason, 
	        ErrorURL and Message are being used as a distinguishing signature.
        </li>
    </ul>
    
    <div style="margin-bottom:10px; margin-top:20px;">
        <a name="SampleError"></a>
        The following error <u>sample</u> can be generated using the EasyErrorHandler class and then be sent via email<br />
    </div>

    <div style='font-family:Tahoma,Arial,Times New Roman;font-size:3.5mm;color:RGB(31,73,125);'>

    <table cellpadding='5' cellspacing='0' 
        style='background-color:#F6EEEE; border-style:solid; border-color:#E00000; border-width:1px; color:Maroon; padding: 10px 10px 10px 10px;
        font-family:Tahoma,Arial,Times New Roman;font-size:3.5mm;color:RGB(31,73,125);'>
      <tr>
        <td valign=top><b>Error&nbsp;URL</b></td>
        <td valign=top><a href="<%=_errorURL%>" target="_blank"
            ><span style="font-family:Tahoma,Arial,Times New Roman;font-size:3.5mm;font-weight:normal;color:Blue; text-decoration:underline;cursor:pointer;"
                ><%=_errorURL%></span></a></td>
      </tr> 
      <tr>
        <td valign=top><b>Request</b></td>
        <td valign=top>N/A</td>
      </tr>
      <tr>
        <td valign=top><b>User&nbsp;Info</b></td>
        <td valign=top>Not Authenticated</td>
      </tr>
      <tr>
        <td valign=top><b>IP&nbsp;Address</b></td>
        <td valign=top><%=_ipAddress%> (<a href="http://www.IP2Location.com/<%=_ipAddress%>" target="_blank" 
            ><span style="font-family:Tahoma,Arial,Times New Roman;font-size:3.5mm;font-weight:normal;color:Blue; text-decoration:underline;cursor:pointer;"
                >http://www.IP2Location.com/<%=_ipAddress%></span></a>)</td>
      </tr>
      <tr>
        <td valign=top><b>Server&nbsp;Info</b></td>
        <td valign=top>Server Name : MY_MACHINE</td>
      </tr>
      <tr>
        <td valign=top><b>Time&nbsp;Stamp</b></td>
        <td valign=top><%=DateTime.Now.ToString()%></td>
      </tr>  
      <tr>
        <td valign=top><b>OS</b></td>
        <td valign=top>WinNT</td>
      </tr>  
      <tr>
        <td valign=top><b>Browser</b></td>
        <td valign=top>IE8 (Internet Explorer Version 8.0), ActiveX=True, AOL=False, Beta=False, Crawler=False, Cookies=True, Frames=True</td>
      </tr>
      <tr>
        <td valign=top><b>Message</b></td>
        <td valign=top>Error for testing</td>
      </tr>
      <tr>
        <td valign=top><b>Source</b></td>
        <td valign=top>System.Web</td>
      </tr>
      <tr>
        <td valign=top><b>Target</b></td>
        <td valign=top>Void OnInit(System.EventArgs)</td>
      </tr>
      <tr>
        <td valign=top><b>Stack&nbsp;Trace</b></td>
        <td valign=top>   at Home.OnInit(EventArgs e) in <%=_errorURL%>:line 31<br />   at System.Web.UI.Control.InitRecursive(Control namingContainer)<br />   at System.Web.UI.Page.ProcessRequestMain(Boolean includeStagesBeforeAsyncPoint, Boolean includeStagesAfterAsyncPoint)</td>
      </tr>
      <tr>
        <td valign=top><b>Inner Ex</b></td>
        <td valign=top>N/A</td>
      </tr>
      <tr>
        <td valign=top><b>Form&nbsp;Data</b></td>
        <td valign=top>N/A</td>
      </tr>                                                  
    </table>

    </div>
    
</div>

</asp:Content>