<%@ Page 
    Language="C#"
    Inherits="Demo_HTTPCompressionModule"
    CodeFile="HTTPCompressionModule.aspx.cs"
    MasterPageFile="~/App_Pages/Home.master"
    AutoEventWireup="true"
    EnableTheming="true"
    Theme="Default"
    Title="MicroMighty, Inc : HTTPCompressionModule"
%>
<asp:Content Runat="Server" ID="_body" ContentPlaceHolderID="_contentPlaceHolderBody">

<div style="margin-left:10px;">

    <div style="margin-bottom:30px;">
        <table cellpadding="0" cellspacing="0">
            <tr>
                <td align="left" class="BoxFixedSilverLeft" style="vertical-align:top;">
                </td>
                
                <td class="BoxFixedSilverMiddle" style="vertical-align:top; padding-left:20px; padding-right:20px;">
                    <div style="margin-top:17px; margin-bottom:3px;">
                        <span class="Title">HTTPCompressionModule Class</span><br />
                    </div>
                    <a href="<%=Page.ResolveUrl("~/Docs/html/N_MicroMighty_SDK_Web_HttpModules.htm")%>" 
                        target="_blank"><span class="Copyright" style="font-weight:normal; cursor:pointer;"
                        >MicroMighty.SDK.Web.HttpModules Namespace</span></a><br />
                </td>
                
                <td align="right" class="BoxFixedSilverRight" style="vertical-align:top;">
                </td>
            </tr>
        </table>
    </div>

    <div style="margin-bottom:30px;">

        <div style="margin-bottom:10px;">
            <table cellpadding="0" cellspacing="0">
                <tr>
                    <td align="left" class="BoxFixedShortSilverLeft" style="vertical-align:top;">
                    </td>
                    
                    <td align="left" class="BoxFixedShortSilverMiddle" style="vertical-align:top;">
                        <div style="margin-top:13px; margin-left:20px; margin-right:20px;">
                            <span class="Title">Usage</span>
                        </div>
                    </td>
                    
                    <td align="right" class="BoxFixedShortSilverRight" style="vertical-align:top;">
                    </td>
                </tr>
            </table>
        </div>
        
        <div style="margin-bottom:30px;">
            This HTTP module is running automatically when it is added to a web project as described below,<br />
            A reference to the SDK DLLs is required, see <a href="<%=Page.ResolveUrl("~/AddReference.aspx")%>" 
                >how to add a reference to the MicroMighty SDK DLLs</a>,<br />
            To further analyze the HTTP response you can use of tools such as <a href="http://www.fiddler2.com/" target="_blank">Fiddler</a> and <a href="http://www.ieinspector.com/" 
	            target="_blank">IEHttpAnalyzer</a><br />                
        </div>

        <div style="margin-bottom:10px;">
            <table cellpadding="0" cellspacing="0">
                <tr>
                    <td align="left" class="BoxFixedShortSilverLeft" style="vertical-align:top;">
                    </td>
                    
                    <td align="left" class="BoxFixedShortSilverMiddle" style="vertical-align:top;">
                        <div style="margin-top:13px; margin-left:20px; margin-right:20px;">
                            <span class="Title">Configuration</span>
                        </div>
                    </td>
                    
                    <td align="right" class="BoxFixedShortSilverRight" style="vertical-align:top;">
                    </td>
                </tr>
            </table>
        </div>
        Web.Config should include the following variables in order for the HTTP Compression Module to run,<br />
        If no variables added then the module will not run and HTTPCompressionActive will be set to "false".<br />
        
        <div style="margin-top:20px;margin-bottom:20px;">
            <u>STEP 1</u> : Add the following entries in the "&lt;appSettings&gt;" section of "&lt;configuration&gt;"<br />
        </div>

        <div class="AreaWrap">
            <font color="#0000ff" size="2"><font color="#0000ff" size="2">&lt;!--<font color="#008000" size="2"><font color="#008000" size="2"
            > HTTPCompressionModule Variables </font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">--&gt;</font></font></font><br />

            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >key</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >HTTPCompressionActive</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >value</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            >true</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />
            
            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >key</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >HTTPCompressionCompressPostBacks</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >value</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            >false</font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />

            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >key</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >HTTPCompressionCommaSeparatedAllowedMIMETypes</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            ><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;value</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            >text/html, text/css, application/x-javascript, text/javascript, text/plain, text/xml</font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />

            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >key</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >HTTPCompressionCommaSeparatedAllowedResponseStatusCodes</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >value</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            >200, 304</font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />

            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >key</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >HTTPCompressionCommaSeparatedExcludedPathAndFileNames</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            ><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;value</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            >.axd, NoCompression.aspx</font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />

            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >key</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >HTTPCompressionInternetExplorerMinimumAllowedVersion</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >value</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            >6.0</font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />
            
            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >key</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >HTTPCompressionTestModeOnly</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >value</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            >false</font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />
        </div>

        <div style="margin-top:20px;margin-bottom:20px;">
            <u>STEP 2</u> : Add the following entries in the "&lt;system.webServer&gt;" section of "&lt;configuration&gt;"<br />
        </div>
        
        <div class="AreaWrap">
            <font color="#0000ff" size="2"><font color="#0000ff" size="2">&lt;!--<font color="#008000" size="2"><font color="#008000" size="2"
            > Disable other HTTP compressions to avoid compression conflicts on IIS 7 and above </font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">--&gt;</font></font></font></font><br />

            <span style='font-size:10.0pt;line-height:115%;font-family:"Courier New";color:blue;mso-no-proof:yes'>&lt;</span><span
            style='font-size:10.0pt;line-height:115%;font-family:"Courier New";color:#A31515;
            mso-no-proof:yes'>urlCompression</span><span style='font-size:10.0pt;
            line-height:115%;font-family:"Courier New";color:blue;mso-no-proof:yes'> </span><span
            style='font-size:10.0pt;line-height:115%;font-family:"Courier New";color:red;
            mso-no-proof:yes'>doStaticCompression</span><span style='font-size:10.0pt;
            line-height:115%;font-family:"Courier New";color:blue;mso-no-proof:yes'>=</span><span
            style='font-size:10.0pt;line-height:115%;font-family:"Courier New";mso-no-proof:
            yes'>&quot;<span style='color:blue'>false</span>&quot;<span style='color:blue'>
            </span><span style='color:red'>doDynamicCompression</span><span
            style='color:blue'>=</span>&quot;<span style='color:blue'>false</span>&quot;<span
            style='color:blue'> </span><span style='color:red'>dynamicCompressionBeforeCache</span><span
            style='color:blue'>=</span>&quot;<span style='color:blue'>false</span>&quot;<span
            style='color:blue'> /&gt;</span></span>
        </div>

        <div style="margin-top:20px;margin-bottom:20px;">
            <u>STEP 3</u> : Add the following entries in the "&lt;httpModules&gt;" section of "&lt;system.web&gt;"<br />
        </div>
        
        <div class="AreaWrap">
            <font color="#0000ff" size="2"><font color="#0000ff" size="2">&lt;!--<font color="#008000" size="2"><font color="#008000" size="2"
            > Register HTTP modules for IIS 6.0 and IIS 7.0 running in Classic mode </font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">--&gt;</font></font></font></font><br />
            
            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >name</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >HTTPCompressionModule</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            ><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;type</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            >MicroMighty.SDK.Web.HttpModules.HTTPCompressionModule</font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />
        </div>

        <div style="margin-top:20px;margin-bottom:20px;">
            <u>STEP 4</u> : Add the following entries in the "&lt;modules&gt;" section of "&lt;system.webServer&gt;"<br />
        </div>

        <div class="AreaWrap">
            <font color="#0000ff" size="2"><font color="#0000ff" size="2">&lt;!--<font color="#008000" size="2"><font color="#008000" size="2"
            > Register HTTP modules for IIS 7.0 running in Integrated mode </font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">--&gt;</font></font></font></font><br />

            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >name</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >HTTPCompressionModule</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            ><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;type</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            >MicroMighty.SDK.Web.HttpModules.HTTPCompressionModule</font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />
        </div>
    </div>

    <div style="margin-bottom:10px;">
        <table cellpadding="0" cellspacing="0">
            <tr>
                <td align="left" class="BoxFixedShortSilverLeft" style="vertical-align:top;">
                </td>
                
                <td align="left" class="BoxFixedShortSilverMiddle" style="vertical-align:top;">
                    <div style="margin-top:13px; margin-left:20px; margin-right:20px;">
                        <span class="Title">Notes</span>
                    </div>
                </td>
                
                <td align="right" class="BoxFixedShortSilverRight" style="vertical-align:top;">
                </td>
            </tr>
        </table>
    </div>

    <div style="margin-bottom:10px;">
        The default settings above are suggested in order to make sure that your compression module will work smoothly
        with other web content such as AJAX requests that may already contain compressed data.<br />
    </div>
    <div style="margin-bottom:10px;">
        This HTTP Compression Module allow turning on and off some compression features, however,<br />
        if you choose to modify the defaults then please test it carefully (especially AJAX enabled pages).
    </div>
    <div style="margin-bottom:20px;">
        Depends on your IIS settings - you may need to enforce HTTP modules on HTML and maybe other files,<br />
        By default ASPX files are processed through the ASP.NET pipeline, however, you may need to configure IIS to 
        route HTML files (and maybe other files) through the <a href="http://learn.iis.net/page.aspx/244/how-to-take-advantage-of-the-iis7-integrated-pipeline/"
            target="http://learn.iis.net/page.aspx/244/how-to-take-advantage-of-the-iis7-integrated-pipeline/"
            >ASP.NET pipeline</a> or move to <a href="http://msdn.microsoft.com/en-us/library/bb515251.aspx" 
            target="_blank">IIS Integrated Mode</a>.<br />
    </div>
    
    <ul class="CustomUL">
        <li class="ArrowBlack" style="text-align:justify;"><b>HTTPCompressionCommaSeparatedAllowedResponseStatusCodes</b> is used in order to make sure 
            that the HTTP module is not intercepting every response but just the ones who can be compressed 
            (see a list of status codes at <a href="http://msdn.microsoft.com/en-us/library/aa383887.aspx" 
                target="_blank">http://msdn.microsoft.com/en-us/library/aa383887.aspx</a>)</li>
                
        <li class="ArrowBlack" style="text-align:justify;"><b>HTTPCompressionCommaSeparatedExcludedPathAndFileNames</b>
            is used in order to exclude specific pages from being compressed (for example, the web page 
            <a href="<%=Page.ResolveUrl("~/HTTPCompressionModule/NoCompression.aspx")%>">NoCompression.aspx</a>
            will not be compressed), by default any page with the extention of ".axd" 
            is excluded from compression since these pages are often used to pass data between 
            AJAX controls and may fail to compress.
        </li>
        
	    <li class="ArrowBlack" style="text-align:justify;"><b>HTTPCompressionInternetExplorerMinimumAllowedVersion</b>
	        is used to decide what will be the minimum version of Internet Explorer in order for the compression to take place
	        (in some scenarios older versions of Internet Explorer are reported to have problems with compression)
	    </li>
	    
	    <li class="ArrowBlack" style="text-align:justify;"><b>HTTPCompressionTestModeOnly</b>
	        is used for testing only in order to print the compressed URL without compressing it,
	        so a developer can get some indication on what page is being processed.<br />
	        To further analyze the HTTP response you can use of tools such as <a href="http://www.fiddler2.com/" target="_blank">Fiddler</a> and <a href="http://www.ieinspector.com/" 
	            target="_blank">IEHttpAnalyzer</a><br />
        </li>
    </ul>

</div>

</asp:Content>