<%@ Page 
    Language="C#"
    Inherits="Demo_HTTPPrefixModule"
    CodeFile="HTTPPrefixModule.aspx.cs"
    MasterPageFile="~/App_Pages/Home.master"
    AutoEventWireup="true"
    EnableTheming="true"
    Theme="Default"
    Title="MicroMighty, Inc : HTTPPrefixModule"
%>
<asp:Content Runat="Server" ID="_body" ContentPlaceHolderID="_contentPlaceHolderBody">
    
<div style="margin-left:10px;">

    <div style="margin-bottom:30px;">
        <table cellpadding="0" cellspacing="0">
            <tr>
                <td align="left" class="BoxFixedSilverLeft" style="vertical-align:top;">
                </td>
                
                <td class="BoxFixedSilverMiddle" style="vertical-align:top; padding-left:20px; padding-right:20px;">
                    <div style="margin-top:17px; margin-bottom:3px;">
                        <span class="Title">HTTPPrefixModule Class</span><br />
                    </div>
                    <a href="<%=Page.ResolveUrl("~/Docs/html/N_MicroMighty_SDK_Web_HttpModules.htm")%>" 
                        target="_blank"><span class="Copyright" style="font-weight:normal; cursor:pointer;"
                        >MicroMighty.SDK.Web.HttpModules Namespace</span></a><br />
                </td>
                
                <td align="right" class="BoxFixedSilverRight" style="vertical-align:top;">
                </td>
            </tr>
        </table>
    </div>

    <div style="margin-bottom:30px;">

        <div style="margin-bottom:10px;">
            <table cellpadding="0" cellspacing="0">
                <tr>
                    <td align="left" class="BoxFixedShortSilverLeft" style="vertical-align:top;">
                    </td>
                    
                    <td align="left" class="BoxFixedShortSilverMiddle" style="vertical-align:top;">
                        <div style="margin-top:13px; margin-left:20px; margin-right:20px;">
                            <span class="Title">Usage</span>
                        </div>
                    </td>
                    
                    <td align="right" class="BoxFixedShortSilverRight" style="vertical-align:top;">
                    </td>
                </tr>
            </table>
        </div>
        <div style="margin-bottom:30px;">
            This HTTP module is running automatically when it is added to a web project as described below,<br />
            A reference to the SDK DLLs is required, see <a href="<%=Page.ResolveUrl("~/AddReference.aspx")%>" 
                >how to add a reference to the MicroMighty SDK DLLs</a>,<br />
            To further analyze the HTTP response you can use of tools such as <a href="http://www.ieinspector.com/" 
	            target="_blank">IEHttpAnalyzer</a> and <a href="http://www.iewatch.com/" target="_blank">IEWatch</a><br />
        </div>

        <div style="margin-bottom:10px;">
            <table cellpadding="0" cellspacing="0">
                <tr>
                    <td align="left" class="BoxFixedShortSilverLeft" style="vertical-align:top;">
                    </td>
                    
                    <td align="left" class="BoxFixedShortSilverMiddle" style="vertical-align:top;">
                        <div style="margin-top:13px; margin-left:20px; margin-right:20px;">
                            <span class="Title">Configuration</span>
                        </div>
                    </td>
                    
                    <td align="right" class="BoxFixedShortSilverRight" style="vertical-align:top;">
                    </td>
                </tr>
            </table>
        </div>
        Web.Config should include the following variables in order for the HTTP Prefix Module to run,<br />
        If no variables added then the module will not run and HTTPPrefixModule will be set to "false".<br />
        
        <div style="margin-top:20px;margin-bottom:20px;">
            <u>STEP 1</u> : Add the following entries in the "&lt;appSettings&gt;" section of "&lt;configuration&gt;"<br />
        </div>

        <div class="AreaWrap">
            <font color="#0000ff" size="2"><font color="#0000ff" size="2">&lt;!--<font color="#008000" size="2"><font color="#008000" size="2"
            > HTTPPrefixModule Variables </font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">--&gt;</font></font></font><br />

            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >key</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >HTTPPrefixActive</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >value</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            >true</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />
            
            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >key</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >HTTPPrefixCommaSeparatedExcludedExtensions</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >value</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            ></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />

            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >key</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >HTTPPrefixCommaSeparatedSSLPathAndFileNames</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >value</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            >PaymentPage.aspx</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font></font><br />

            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >key</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >HTTPPrefixEnforcePrefixInAddress</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >value</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            >false</font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />

            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >key</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >HTTPPrefixEnforceNoPrefixInAddress</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >value</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            >true</font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />

            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >key</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >HTTPPrefixHostPrefix</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >value</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            >www.</font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />
            
            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >key</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >HTTPPrefixTestModeOnly</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >value</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            >false</font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />
        </div>

        <div style="margin-top:20px;margin-bottom:20px;">
            <u>STEP 2</u> : Add the following entries in the "&lt;httpModules&gt;" section of "&lt;system.web&gt;"<br />
        </div>
        
        <div class="AreaWrap">
            <font color="#0000ff" size="2"><font color="#0000ff" size="2">&lt;!--<font color="#008000" size="2"><font color="#008000" size="2"
            > Register HTTP modules for IIS 6.0 and IIS 7.0 running in Classic mode </font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">--&gt;</font></font></font></font><br />
            
            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >name</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >HTTPPrefixModule</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >type</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            >MicroMighty.SDK.Web.HttpModules.HTTPPrefixModule</font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />
        </div>

        <div style="margin-top:20px;margin-bottom:20px;">
            <u>STEP 3</u> : Add the following entries in the "&lt;modules&gt;" section of "&lt;system.webServer&gt;"<br />
        </div>

        <div class="AreaWrap">
            <font color="#0000ff" size="2"><font color="#0000ff" size="2">&lt;!--<font color="#008000" size="2"><font color="#008000" size="2"
            > Register HTTP modules for IIS 7.0 running in Integrated mode </font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">--&gt;</font></font></font></font><br />

            <font color="#0000ff" size="2">&lt;<font color="#a31515" size="2"><font color="#a31515" size="2">add</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >name</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"
            >HTTPPrefixModule</font></font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> </font></font><font color="#ff0000" size="2"><font color="#ff0000" size="2"
            >type</font></font><font color="#0000ff" size="2"><font color="#0000ff" size="2">=</font></font><font color="#000000" size="2">"</font
            >MicroMighty.SDK.Web.HttpModules.HTTPPrefixModule</font><font color="#000000" size="2">"</font><font color="#0000ff" size="2"><font color="#0000ff" size="2"> /&gt;</font></font><br />
        </div>
    </div>

    <div style="margin-bottom:10px;">
        <table cellpadding="0" cellspacing="0">
            <tr>
                <td align="left" class="BoxFixedShortSilverLeft" style="vertical-align:top;">
                </td>
                
                <td align="left" class="BoxFixedShortSilverMiddle" style="vertical-align:top;">
                    <div style="margin-top:13px; margin-left:20px; margin-right:20px;">
                        <span class="Title">Notes</span>
                    </div>
                </td>
                
                <td align="right" class="BoxFixedShortSilverRight" style="vertical-align:top;">
                </td>
            </tr>
        </table>
    </div>
    <div style="margin-bottom:10px;">
        Depends on your IIS settings - you may need to enforce HTTP modules on HTML and maybe other files,<br />
        By default ASPX files are processed through the ASP.NET pipeline, however, you may need to configure IIS to 
        route HTML files (and maybe other files) through the <a href="http://learn.iis.net/page.aspx/244/how-to-take-advantage-of-the-iis7-integrated-pipeline/"
            target="http://learn.iis.net/page.aspx/244/how-to-take-advantage-of-the-iis7-integrated-pipeline/"
            >ASP.NET pipeline</a> or move to <a href="http://msdn.microsoft.com/en-us/library/bb515251.aspx" 
            target="_blank">IIS Integrated Mode</a>.<br />
    </div>
    <div style="margin-bottom:20px;">

    </div>
    
    <ul class="CustomUL">
        <li class="ArrowBlack" style="text-align:justify;"><b>HTTPPrefixCommaSeparatedSSLPathAndFileNames</b> 
            is used to define pages that will be added with the "https" prefix for Secure Socket Layer (SSL), 
            for example <a href="<%=Page.ResolveUrl("~/HTTPPrefixModule/PaymentPage.aspx")%>" 
                >PaymentPage.aspx</a><br />
            (please note that the URL will be broken if no valid SSL certificate was setup on the domain)
	    </li>
	    
	    <li class="ArrowBlack" style="text-align:justify;"><b>HTTPPrefixHostPrefix</b>
	        can be set temporally to "localhost" in order to help debugging locally.<br />
	    </li>
	    
	    <li class="ArrowBlack" style="text-align:justify;"><b>HTTPPrefixTestModeOnly</b>
	        is used for testing only in order to print the processed URL without redirecting to it,
	        so a developer can get some indication on what page is being processed.<br />
            To further analyze the HTTP response you can use of tools such as <a href="http://www.ieinspector.com/" 
	            target="_blank">IEHttpAnalyzer</a> and <a href="http://www.iewatch.com/" target="_blank">IEWatch</a><br />
        </li>
    </ul>

</div>

</asp:Content>