// --------------------------------------------------------------------------------
// MicroMighty Software Development Kit (SDK)
// --------------------------------------------------------------------------------
// Copyright By MicroMighty, Inc. All Rights Reserved.
//
// You can use this SDK for personal use only, any commercial use or use for other 
// type of organization including non profit on a production server is not allowed.
//
// You may not publish, sell, re-distribute, rent, lease or re-license any content
// contained in this source code and/or DLLs and/or other components of the SDK 
// without an explicit written permission agreement signed by MicroMighty, Inc.
//
// MicroMighty, Inc. reserves the right to permanently cancel without any warnings
// neither refund a license that is suspected of being used illegitimately or that
// violates the EULA (http://MicroMighty.com/Components/MicroMighty_SDK/EULA)
// --------------------------------------------------------------------------------

using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Reflection;

public partial class App_Pages_Home : System.Web.UI.MasterPage
{
    protected override void OnInit(EventArgs e)
    {
        base.OnInit(e);

        Assembly assembly;

        assembly = Assembly.ReflectionOnlyLoad("MicroMighty.SDK.Net");
        _versionSDKNet.Text = assembly.GetName().Version.ToString();

        assembly = Assembly.ReflectionOnlyLoad("MicroMighty.SDK.Web");
        _versionSDKWeb.Text = assembly.GetName().Version.ToString();
    }

    protected void Page_Load(object sender, EventArgs e)
    {
    }
}